Index: /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90
===================================================================
--- /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 5206)
+++ /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 5207)
@@ -340,5 +340,5 @@
          CALL tab_1d_2d_2( nbpb, qsr_ice(:,:,1), npb, qsr_ice_1d(1:nbpb)  , jpi, jpj )
          CALL tab_1d_2d_2( nbpb, qns_ice(:,:,1), npb, qns_ice_1d(1:nbpb)  , jpi, jpj )
-         IF( l_trcdm2dc ) &
+         IF( l_trcdm2dc ) THEN
             CALL tab_1d_2d_2( nbpb, fstric_mean        , npb, fstbif_mean_1d (1:nbpb), jpi, jpj )
             CALL tab_1d_2d_2( nbpb, qsr_ice_mean(:,:,1), npb, qsr_ice_mean_1d(1:nbpb), jpi, jpj )
Index: /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_2/limthd_zdf_2.F90
===================================================================
--- /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 5206)
+++ /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 5207)
@@ -18,5 +18,5 @@
    USE ice_2
    USE limistate_2
-   USE sbc_oce, ONLY : lk_cpl
+   USE sbc_oce, ONLY : lk_cpl, l_trcdm2dc
    USE in_out_manager
    USE lib_mpp          ! MPP library
@@ -273,5 +273,5 @@
        END DO
 
-       IF( l_topdcy )THEN
+       IF( l_trcdm2dc )THEN
           !
           DO ji = kideb , kiut
Index: /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90
===================================================================
--- /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 5206)
+++ /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 5207)
@@ -220,5 +220,15 @@
 
       !   daily mean qsr when diurnal cycle is applied on physics - for BGC models
-      IF( l_trcdm2dc ) qsr_mean(:,:) =  pfrld(:,:) * qsr_mean(:,:) +  ftr_ice_mean(:,:)
+      IF( l_trcdm2dc ) THEN
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zfcm1 = pfrld(ji,jj) * qsr_mean(ji,jj)
+               DO jl = 1, jpl
+                  zfcm1 = zfcm1 + ftr_ice_mean(ji,jj,jl)
+               END DO
+               qsr_mean(ji,jj) = zfcm1                                      
+            ENDDO
+         ENDDO
+      ENDIF
 
       !------------------------------------------------!
Index: /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90
===================================================================
--- /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 5206)
+++ /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 5207)
@@ -680,5 +680,5 @@
          !         
          IF( l_trcdm2dc )  THEN
-            CALL tab_1d_2d( nbpb, qns_ice_mean(:,:,jl), npb, qns_ice_mean_1d(1:nbpb) , jpi, jpj)
+            CALL tab_1d_2d( nbpb, qsr_ice_mean(:,:,jl), npb, qsr_ice_mean_1d(1:nbpb) , jpi, jpj)
             CALL tab_1d_2d( nbpb, ftr_ice_mean(:,:,jl), npb, ftr_ice_mean_1d(1:nbpb) , jpi, jpj )
          ENDIF
Index: /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90
===================================================================
--- /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 5206)
+++ /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 5207)
@@ -24,5 +24,5 @@
    USE wrk_nemo       ! work arrays
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
-   USE sbc_oce, ONLY : lk_cpl
+   USE sbc_oce, ONLY : lk_cpl, l_trcdm2dc
 
    IMPLICIT NONE
@@ -294,8 +294,8 @@
       IF( l_trcdm2dc ) THEN
          DO ji = kideb , kiut
-             ftr_ice_mean_1d(ji) =  ftr_ice_mean_1d(ji) & 
-                 &                + a_i_1d(ji) * zftrice_mean(ji) &
-                 &                             * EXP( - rn_kappa_i * ( MAX ( 0._wp , h_i_1d(ji) ) ) ) &
-                                               * EXP( - zraext_s   * ( MAX ( 0._wp , h_s_1d(ji) ) ) )
+             ftr_ice_mean_1d(ji) =  ftr_ice_mean_1d(ji)               & 
+                 &                + a_i_1d(ji) * zftrice_mean(ji)     &
+                 &                             * EXP( - rn_kappa_i * ( MAX ( 0._wp , ht_i_1d(ji) ) ) ) &
+                 &                             * EXP( - zraext_s   * ( MAX ( 0._wp , ht_s_1d(ji) ) ) )
          END DO
       ENDIF
Index: /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 5206)
+++ /branches/2015/dev_r5204_CNRS_PISCES_dcy/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 5207)
@@ -195,5 +195,5 @@
                &                      fr1_i0     , fr2_i0     , cp_ice_msh , jpl  )
 
-            IF( ltrcdm2dc_ice )   CALL blk_ice_meanqsr( zalb_ice, qsr_ice_mean, jpl )
+            IF( l_trcdm2dc )   CALL blk_ice_meanqsr( zalb_ice, qsr_ice_mean, jpl )
 
          CASE( jp_cpl )            ! Coupled formulation : atmosphere-ice stress only (fluxes provided after ice dynamics)